/*
 * Java-Klassen laden.
 */
var FCproCLient = Java.type("ifresco.fcpro.client.FCproClient");
var FCproStatus = Java.type("ifresco.fcpro.client.FCproStatus");
var FCproUser = Java.type("ifresco.fcpro.client.FCproUser");

/*
 * Setup des Clients.
 */
var client = new FCproCLient();
client.setEndpoint("https://fileconverterpro.xkey.at:8007/FileConverterProREST");
client.setUser("admin");
client.setPassword("fileconverter");
client.setApiHash(26984);

/*
 * Einige Informationen über den Server abrufen.
 */
print("==== getUsers ====");
var users = client.getUsers();
for (var i in users) {
    var user = users[i];
    print(userFilter);
}

print("==== Server-Zustand ====");
print("isStarted():\t" + client.isStarted());
// Weiter Methoden:
// client.startServer();
// client.stopServer();
print("getServerHash():\t" + client.getServerHash());
print("getServerVersion():\t" + client.getServerVersion());
print("getAvgSecPerPage():\t" + client.getAvgSecPerPage());
print("getNrOfDocumentsInQueue():\t" + client.getNrOfDocumentsInQueue());
print("getNrOfPagesInQueue():\t" + client.getNrOfPagesInQueue());
print("getAvailablePages():\t" + client.getAvailablePages());

/*
 * Die Settings entsprechen den möglichen Konvertierungen. Beim Upload eines
 * File zur Konvertierung muss ein Setting durch seinen Namen angegeben werden.
 */
print("==== getSettings ====");
var settings = client.getSettings();
for (var i in settings) {
    var setting = settings[i];
    print(setting.settingsName);
    /*
     * weitere Felder von setting:
     * String description
     * String engineName
     * List<String> additonalOutput
     * List<String> inputFormats
     * List<String> inputFormatsMT
     * List<String> outputFormats
     * List<String> outputFormatsMT
     */
}

/*
 * Jobs auf dem Server auflisten.
 * 
 * Die Enumeration FCproStatus hat diese Werte:
 * ALL, INVALID, CREATED, UPLOADED, CONVERTING, CONVERTED,
 * DOWNLOADED, CONVERSION_ERROR, EXPIRED, CANCELED
 */

// Hilfsfunktion.
var printJobs = function (jobs) {
    for (var i in jobs) {
        var job = jobs[i];
        print(job);
    }
};

print("==== getOwnJobs(DOWNLOADED) ====");
var state = FCproStatus.DOWNLOADED;
printJobs(client.getOwnJobs(state));

print("==== getAllJobs ====");
printJobs(client.getAllJobs());

print("==== removeJob ====");
var errorJobs = client.getAllJobs(FCproStatus.CONVERSION_ERROR);
for (var i in errorJobs) {
    var job = errorJobs[i];
    client.cancelJob(job.getGuid);
    client.removeJob(job.getGuid);
}

/*
 * Jobs können seitenweise sortiert und gefiltert abgerufen werden.
 */
print("==== enumJobs ====");
var pageSize = 10;
var labelFilter = "*JavaScript*";
var userFilter = new FCproUser("admin");
var createdFromToFilter = null; // optionaler Filter, Datums-String
var convertedFromToFilter = null; // optionaler Filter, Datums-String
// mögliche sortColumns: "JobLabel ASC", "JobLabel DESC", "UserName ASC", "UserName DESC", "StatusCode ASC", "StatusCode DESC",
// "DateCreated ASC", "DateCreated DESC", "DateConverted ASC", "DateConverted DESC", "DateCreated ASC"
var sortColumns = "JobLabel ASC";
var jobsEnum = client.enumJobs(pageSize, labelFilter, userFilter, FCproStatus.DOWNLOADED, createdFromToFilter, convertedFromToFilter, sortColumns);
print(jobsEnum);
for (var page = 1; page <= jobsEnum.pagesCount; page++) {
    print("page=" + page);
    var jobsOnPage = client.enumJobsGetPage(jobsEnum.jobEnumID, page);
    printJobs(jobsOnPage);
}

/*
 * Ein java.io.File kann zur Konvertierung hochgeladen werden. Das Ergebnis ist ein Job,
 * dessen Status aberufen werden kann.
 */
print("==== upload ====");
var f = new java.io.File("example.pdf");
var targetExtension = "pdf";
var settingsName = "Direct + iOCR German";
var label = "example pdf conversion from JavaScript";
var uploadJob = client.upload(f, targetExtension, settingsName, label);
print(uploadJob);
var guid = uploadJob.guid;
print("getJob(guid):\t" + client.getJob(guid));
print("getStatus(guid):\t" + client.getStatus(guid));
/*
 * Weiter Felder des Jobs:
 * String guid
 * int jobId
 * int pageCount
 * FCproStatus status
 * String owner
 * String error
 * String label
 * Date created
 * Date converted
 */

/*
 * Ein Job kann heruntergeladen werden und lokal in einem java.io.File gespeichert werden.
 */
print("==== download ====");
var timeout = 10000; // 10 Sekunden
var sleeptime = 1000; // 1 Sekunde
var completionStatus = client.waitForCompletion(guid, timeout, sleeptime);
if (completionStatus === FCproStatus.CONVERTED) {
    var output = new java.io.File("example-converted.pdf");
    client.download(guid, output);
    print("Download nach " + output);
} else {
    print("Konvertierung fehlgeschlagen: " + completionStatus);
}

/*
 * Weitere Methoden von client:
 * 
 * client.deleteAllJobs()
 * client.deleteJobsOlderThanDays(days)
 */
