package ifresco.fcpro.client;

/**
 * Indicates an invalid API Key on the AutoOCR Server.
 *
 * @since 1.0
 */
public class ApiKeyInvalidException extends RuntimeException {

    private static final long serialVersionUID = 1L;

    /**
     * Constructor with an exception message.
     *
     * @param msg the message
     */
    public ApiKeyInvalidException(String msg) {
        super(msg);
    }

    /**
     * Constructor with an exception mesage and a {@code Throwable}.
     *
     * @param msg the message
     * @param t the {@code Throwable}
     */
    public ApiKeyInvalidException(String msg, Throwable t) {
        super(msg, t);
    }
}
