package ifresco.fcpro.client;

/**
 * Available FCpro status from http://www.pdfblog.at/?p=1756.
 *
 * @since 1.0
 */
public enum FCproStatus {

    /**
     *
     */
    ALL,
    /**
     *
     */
    INVALID,
    /**
     *
     */
    CREATED,
    /**
     *
     */
    UPLOADED,
    /**
     *
     */
    CONVERTING,
    /**
     *
     */
    CONVERTED,
    /**
     *
     */
    DOWNLOADED,
    /**
     *
     */
    CONVERSION_ERROR,
    /**
     *
     */
    EXPIRED,
    /**
     *
     */
    CANCELED;

    /**
     * Marshals a {@link FCproStatus} enum into the AutoOCR int value.
     *
     * @param status the status
     * @return the integer value
     */
    public static int toIntValue(FCproStatus status) {
        switch (status) {
            case ALL:
                return 100;
            case INVALID:
                return 0;
            case CREATED:
                return 1;
            case UPLOADED:
                return 2;
            case CONVERTING:
                return 3;
            case CONVERTED:
                return 4;
            case DOWNLOADED:
                return 5;
            case CONVERSION_ERROR:
                return 6;
            case EXPIRED:
                return 7;
            case CANCELED:
                return 8;
        }
        throw new RuntimeException("unkown status: " + status);
    }

    /**
     * Unmarshals a status value to a {@link FCproStatus} enum.
     *
     * @param val the integer value
     * @return the status
     */
    public static FCproStatus getStatusFromValue(int val) {
        switch (val) {
            case 100:
                return FCproStatus.ALL;
            case 1:
                return FCproStatus.CREATED;
            case 2:
                return FCproStatus.UPLOADED;
            case 3:
                return FCproStatus.CONVERTING;
            case 4:
                return FCproStatus.CONVERTED;
            case 5:
                return FCproStatus.DOWNLOADED;
            case 6:
                return FCproStatus.CONVERSION_ERROR;
            case 7:
                return FCproStatus.EXPIRED;
            case 8:
                return FCproStatus.CANCELED;
            default:
                return FCproStatus.INVALID;
        }
    }
}
