package ifresco.fcpro.client;

import java.io.IOException;
import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.client.ClientProtocolException;
import org.apache.http.client.ResponseHandler;
import org.apache.http.util.EntityUtils;

/**
 * Handler for String responses applicable to be held in memory.
 *
 * @since 1.0
 */
public class StringResponseHandler implements ResponseHandler<String> {

    @Override
    public String handleResponse(HttpResponse response)
            throws ClientProtocolException, IOException {
        int status = response.getStatusLine().getStatusCode();
        if (status != 200) {
            throw new RuntimeException("HTTP error " + response.getStatusLine());
        }

        HttpEntity entity = response.getEntity();

        if (entity == null) {
            throw new RuntimeException("Expected an HTTP entity.");
        }

        return EntityUtils.toString(entity);
    }
}
